


#include "stdafx.h"


#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <locale.h>
#include <string.h>
#include <time.h>

#include "windows.h"
#include "shlobj.h"

#include "os.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "etc.h"
#include "font.h"
#include "timex.h"
#include "config.h"
#include "osreg.h"
#include "wimp.h"
#include "wos.h"
#include "oserr.h"
#include "osthread.h"
#include "deb.h"


int verbose;


void terminate(char * format, ...)
{
 va_list   args;
 char      v[512];

 va_start(args, format);
 vsprintf(v, format, args);

 fprintf(stderr,"%s\r\n",v);

 va_end(args);

 exit(1);
}



/*****************************************************************************/





//static char gscommand[1024]="\"C:\\Program Files\\gs\\gs8.13\\bin\\gswin32c.exe\"";
//static char mkpreviewcommand[1024]=" -dBATCH -sPAPERSIZE=a4 -sDEVICE=tiff24nc -sOutputFile=%s -r72 -q -dNOPAUSE -dFirstPage=1 -dLastPage=1 %s";
//static char mkepscommand[1024]=" -dBATCH -sPAPERSIZE=a4 -sDEVICE=epswrite -sOutputFile=%s -r600 -q -dNOPAUSE -dFirstPage=1 -dLastPage=1 %s";;


static char gscommand[1024];
static char mkpreviewcommand[1024];
static char mkepscommand[1024];




typedef struct epshdrstr
{
 int magic;
 int psstart;
 int pslength;
 int metastart;
 int metalength;
 int tiffstart;
 int tifflength;
 short int checksum;

} epshdrstr;


#define EPSMAGIC   0xC6D3D0C5
#define EPSHDRSIZE 30




static conlink clink={"pdf",NULL,NULL};
static contag ctags[]=
{
	"psloc",CONSTR,gscommand,(contokstr*)sizeof(gscommand),NULL,
	"mkpreview",CONSTR,mkpreviewcommand,(contokstr*)sizeof(mkpreviewcommand),NULL,
	"mkeps",CONSTR,mkepscommand,(contokstr*)sizeof(mkepscommand),NULL,
		NULL,0,NULL,0,NULL,
};





int main(int argc, char* argv[])
{
 os_error *  err;
	char        scrap[1024];
	char        scrap2[1024];
	epshdrstr   epshdr;
	char      * tpreview;
	char      * teps;
	fstat       fx;
	buffer      bf;
 fshandle    fh;
	int         fpos;
 char      * p;
 int         x;
 int         exitcode;

 err=NULL;

	initcon();
 addcontable(ctags,&clink);

	strcpy(scrap,argv[0]);
	p=fs_leaf(scrap);
	strcpy(p,"transpdf.txt");

//	cprintf("config %s\r\n",scrap);


 loadconfig(scrap);

//	cprintf("gsc %s\r\n",gscommand);

 err=fs_stat(gscommand,&fx);

//	cprintf("fx %d",fx.object);

//	cprintf("arg2 %s",argv[2]);

 tpreview=_tempnam(NULL,NULL);
	teps=_tempnam(NULL,NULL);


	sprintf(scrap,mkpreviewcommand,tpreview,argv[1]);
	sprintf(scrap2,"%s %s",gscommand,scrap);
	err=runexe(scrap2,&exitcode);

	if(err)	cprintf("%s\r\n",err->errmess);

//	cprintf("command %s\r\n",scrap2);

//	cprintf("tpreview %s",tpreview);

	if(!err)
	{
 	sprintf(scrap,mkepscommand,teps,argv[1]);
 	sprintf(scrap2,"%s %s",gscommand,scrap);
 	err=runexe(scrap2,&exitcode);

//	 if(err)	cprintf("%s\r\n",err->errmess);

		if(!err)
		{
   memset(&epshdr,0,sizeof(epshdrstr));
   epshdr.magic=EPSMAGIC;

   err=fs_stat(tpreview,&fx);
			if(!err && fx.object==1)
			{
//					cprintf("found preview");

    epshdr.tiffstart=EPSHDRSIZE;
    epshdr.tifflength=fx.length;
    epshdr.psstart=epshdr.tiffstart+epshdr.tifflength;

	   err=bf_open(argv[2],'w',DEFBUFFSIZE,&bf);
				if(!err)
				{
     err=bf_write(&bf,&epshdr,EPSHDRSIZE);
					if(!err)
     {
      err=fs_open(tpreview,'r',&fh);
      if(!err)
      {
       err=bf_copyn(&bf,fh,fx.length,NULL);
       fs_close(fh,err);
      }

						if(!err)
						{
       err=fs_stat(teps,&fx);
							if(!err && fx.object==1)
							{
        err=fs_open(teps,'r',&fh);
        if(!err)
        {
         err=bf_copyn(&bf,fh,fx.length,NULL);
         fs_close(fh,err);
        }
							}

							if(!err)
							{
        err=bf_tell(&bf,&fpos);
								if(!err)
								{
         epshdr.pslength=fpos-epshdr.psstart;

         p=(char*)&epshdr;

         for(x=0;x<EPSHDRSIZE;x++)
         {
          epshdr.checksum^=*p++;
         }

         epshdr.checksum=-1;  /* ignore */

         err=bf_seek(&bf,0);
         if(!err) err=bf_write(&bf,&epshdr,EPSHDRSIZE);
								}
							}
						}
					}
		   err=bf_close(&bf,err);
				}
			}
		}
	 fs_delete(teps);
	}
 fs_delete(tpreview);

//	if(err)	cprintf("%s\r\n",err->errmess);

//	while(1);

 if(err)
 {
  fprintf(stderr,"%s\r\n",err->errmess);
  return(1);
 }
 else
 {
  return 0;
 }
}
